<template>
  <div id="profileSetting">
    <div class="left">
      <div class="content">
        <div class="title">{{ $t('profile_setting.title') }}</div>
        <div class="change user">
          <span class="iconmo iconmo-KYC"></span>
          <div class="change-description">
            <h6 >{{ $t('profile_setting.kyc_status') }} <label v-if="user.kyc_status >= 0" class="alert" :class="kycStatus[user.kyc_status]">{{ kycStatus[user.kyc_status] }}</label></h6>
            <span>{{ $t('profile_setting.kyc_status.note', {optional: ''}) }}</span>
          </div>
          <button type="button" class="btn-change" @click="$router.push('/users/kyc')" v-if="!user.kyc_status">
            {{ $t('profile_setting.btn_verify') }}
          </button>
        </div>
        <div class="change_password change">
          <span class="iconmo iconmo-password"></span>
          <div class="change-description">
            <h6>{{ $t('profile_setting.login_password') }}</h6>
          </div>
          <button type="button" class="btn-change" @click="changePasswordPopup()">{{ $t('profile_setting.btn_change') }}</button>
        </div>
        <div class="authentication change">
          <span class="iconmo iconmo-google"></span>
          <div class="change-description">
            <h6>{{ $t('profile_setting.authentication.title') }}</h6>
            <span>{{ $t('profile_setting.authentication.description') }}</span>
          </div>
          <button type="button" class="btn-change" v-if="user.two_factor_enabled" @click="openModalConfirm()">{{ $t('profile_setting.btn_disable') }}</button>
          <button type="button" class="btn-change" v-else @click="openOtpModal()">{{ $t('profile_setting.btn_enable') }}</button>
        </div>
        <div class="token_address change">
          <span class="iconmo iconmo-ETH_1"></span>
          <div class="change-description">
            <h6>{{ $t('profile_setting.token_address.label') }}</h6>
            <span>{{ user.token_address || $t('profile_setting.token_address.note') }}</span>
          </div>
          <button type="button" class="btn-change" @click="openChangeAddressModal('token')">
            {{ $t('profile_setting.btn_change') }}
          </button>
        </div>
      </div>
    </div>
    <div class="right">
      <div class="content">
        <div class="referral">
          <div class="referral_qr">
            <qrcode class="qrcode" :value="urlReferral"></qrcode>
          </div>
          <div class="referral_info">
            <div class="referral_id">
              <span>{{ $t('profile_setting.referral.id') }}</span>
              <span class="referral___id">{{ user.referral_id }}</span>
            </div>
            <div class="link">
              <span>{{ $t('profile_setting.referral.link') }}</span>
              <div class="referral_link">
                <a :href="urlReferral" target="_blank">{{ urlReferral }}</a>
                <button type="button" v-clipboard:copy="urlReferral"
                 v-tooltip="{content: 'Copied', trigger: 'focus', autoHide: true, delay: { hide:1000 }}"><span class="iconmo iconmo-copy"></span></button>
              </div>
            </div>
          </div>
        </div>
        <div class="clearfix"></div>
        <div class="content-bottom">
          <div class="number-box">
            <p class="name">{{ $t('profile_setting.referral.registered') }}</p>
            <p class="number">{{ user.referrees }}</p>
          </div>

          <div class="number-box">
            <p class="name">{{ $t('profile_setting.referral.kyc') }}</p>
            <p class="number">{{ user.kycs }}</p>
          </div>

          <div class="number-box">
            <p class="name">{{ $t('profile_setting.referral.deposited') }}</p>
            <p class="number">{{ user.deposit }}</p>
          </div>
        </div>

        <div v-for="currency in currencies" :class="`${currency}_address change`">
          <span class="iconmo">
            <img :src="currency | currencyIcon">
          </span>
          <div class="change-description">
            <h6>{{ $t(`profile_setting.${currency}_address.label`) }}</h6>
            <span>{{ user[`${currency}_address`] || $t(`profile_setting.${currency}_address.note`) }}</span>
          </div>
          <button type="button" class="btn-change" @click="openChangeAddressModal(currency)">
            {{ $t('profile_setting.btn_change') }}
          </button>
        </div>

      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapMutations } from 'vuex';

import rf from '../../common/requests/RequestFactory';
import ChangePasswordModal from './Auth/Modal/ChangePasswordModal';
import OtpModal from '../../common/components/Otp/OtpModal.vue';
import OtpConfirmModal from '../../common/components/Otp/OtpConfirmModal.vue';
import RemoveOtp from '../../common/components/Otp/RemoveOtp.vue';
import ChangeCurrencyAddressModal from '../components/Modal/ChangeCurrencyAddressModal.vue';

export default {
  data (){
    return {
      currencies: ['eth', 'btc', 'usdt'],
      kycStatus: ['unverified', 'pending', 'verified', 'rejected'],
    }
  },
  computed: {
    ...mapState([
      'user',
    ]),
    urlReferral () {
      return this.user ? `${this.$baseUrl}/register?referral_id=${this.user.referral_id}` : '';
    },
  },
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    openOtpModal () {
      this.$broadcast('open-modal', OtpModal);
    },
    changePasswordPopup() {
      this.$broadcast('open-modal', ChangePasswordModal);
    },
    openModalConfirm () {
      this.$broadcast('open-modal', RemoveOtp);
    },
    openChangeAddressModal (currency) {
      this.$broadcast('open-modal', ChangeCurrencyAddressModal, { currency });
    },
  },
  watch: {
    'user.two_factor_enabled': function twoFA() {
      if ((typeof this.user.two_factor_enabled) !== 'undefined' && this.$route.params.type === '2FA') {
        if (this.user.two_factor_enabled) {
          this.openModalConfirm();
        } else {
          this.openOtpModal()
        }
      }
    },
  },
  created () {
    if (this.$route.params.type === 'change-password') {
      this.changePasswordPopup();
    }
    this.$on(`${this._uid}-removeAuthentication-confirm-otp-successful`, (res) => {
      this.updateUser(res.data);
    });

    this.$on('requestChangeETHAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update ETH address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });

    this.$on('requestChangeBTCAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update BTC address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });

    this.$on('requestChangeUSDTAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update USDT address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });

    this.$on('requestChangePassword-confirm-otp-successful', () => {
      this.$toasted.show(this.$t('messages.auth.changePassword.changePasswordSuccessful'), {
        theme: 'bubble',
        position: 'top-right',
        duration : 1000
      });

      setTimeout(() => {
        window.location.href = '/login';
      }, 1000);
    });
  },
}
</script>

<style lang="scss" scoped>
  @import '../../../sass/_variables.scss';

  * {
    font-family: $font-family-home;
  }
  #profileSetting {
    width: 100%;
    min-width: 1130px;
    .right, .left {
      width: 50%;
      float: left;
      height: 100%;
      min-height: 600px;
      .content {
        width: 520px;
      }
      .change {
        width: 100%;
        height: 80px;
        border-radius: 74px;
        display: table;
        padding: 0 25px 0 30px;
        position: relative;
        border: none;
        .btn-change {
          position: absolute;
          display: table-cell;
          width: 85px;
          height: 32px;
          border-radius: 30px;
          background: transparent;
          border: solid 1px #fa7300;
          font-size: 12px;
          font-weight: bold;
          line-height: 2.5;
          letter-spacing: 0.5px;
          color: #fa7300;
          text-transform: uppercase;
          vertical-align: middle;
          transform: translate(-50%,-50%);
          top: 50%;
          right: -15px;
          cursor: pointer;
          outline: none;
           &:hover {
             background: #fa7300;
             color: white;
           }
        }
        .change-description {
          padding-left: 15px;
          vertical-align: middle;
          display: table-cell;
          h6 {
            margin: 0;
            font-size: 16px;
            color: $black;
          }
          span {
            font-size: 14px;
            color: $thin_gray;
          }
        }
        .iconmo {
          font-size: 30px;
          display: table-cell;
          width: 30px;
          vertical-align: middle;
          img {
            width: 100%;
          }
        }
      }
    }
    .left {
      background: $bg_white;
      .content {
        float: right;
        margin-right: 45px;
        .change {
          background: $bg_thin_gray;
          margin-bottom: 25px;
          &.authentication {
            .auth-content {
              span {
                font-size: 14px;
                color: $thin_gray;
              }
            }
          }
          &.user {
            .change-description {
              h6 {
                display: flex;
                .alert {
                  text-transform: uppercase;
                  padding: 4px 0 0;
                  margin: 0 0 0px 10px;
                  width: 82px;
                  height: 20px;
                  border-radius: 30px;
                  background-color: #4a90e2;
                  font-size: 10px;
                  font-weight: bold;
                  text-align: center;
                  color: #ffffff;
                  &.pending {
                    background-color: #fcb202;
                  }
                  &.verified {
                    background-color: #4caf50;
                  }
                  &.rejected {
                    background-color: #d0021b;
                  }
                }
              }
            }
          }
        }
        .title {
          font-size: 30px;
          font-weight: bold;
          font-style: normal;
          font-stretch: normal;
          line-height: normal;
          letter-spacing: normal;
          color: $black;
          margin-top: 62px;
          margin-bottom: 43px;
        }
      }
    }
    .right {
      background: $bg_thin_gray;
      .content {
        float: left;
        margin-left: 42px;
        .referral {
          width: 100%;
          margin-top: 121px;
          height: auto;
          .referral_qr {
            width: 100px;
            height: 100px;
            float: left;
            .qrcode {
              width: 100%;
              height: 100%;
            }
          }
          .referral_info {
            width: calc(100% - 114px);
            float: left;
            margin-left: 14px;
            span {
              font-size: 14px;
              color: $thin_gray;
            }
            .referral_id {
              .referral___id {
                font-size: 14px;
                font-weight: bold;
                line-height: 3.57;
                color: $black;
              }
            }
            .referral_link {
              a {
                font-size: 14px;
                font-weight: bold;
                line-height: 3.57;
                color: $black;
                line-height: normal;
                text-decoration: underline;
              }
              button {
                width: 14px;
                height: 14px;
                border: none;
                background: #f7f7f7;
                text-align: center;
                padding: 0px;
                .iconmo {
                  &:before {
                    color: $thin_gray !important;
                  }
                  cursor: pointer;
                }
              }
            }
          }
        }
        .content-bottom {
          border-top: 1px solid #e0e0e0;
          width: 100%;
          margin: 19px 0 33px;
          padding-top: 19px;
          .number-box {
            width: 110px;
            margin-right: 50px;
            float: left;
            .name {
              font-size: 14px;
              line-height: 1.43;
              color: $thin_gray;
            }
            .number {
              font-size: 20px;
              font-weight: bold;
              color: #505050;
            }
          }
        }
        .eth_address,
        .btc_address,
        .usdt_address {
          background: transparent !important;
          padding: 0 25px 0 15px;
          border: solid 1px #e0e0e0;
          .change-description {
            padding-left: 7px;
          }
        }
        .eth_address {
          border-radius: 10px 10px 0 0;
          border-bottom: none;
        }
        .btc_address {
          border-radius: 0px;
          border-bottom: none;
        }
        .usdt_address {
          border-radius: 0 0 10px 10px;
          margin-bottom: 20px;
        }
        .change {
          background: #e8e8e8;
        }
      }
    }
  }

  @media screen and (max-width: 1200px) {
    #profileSetting {
      min-width: auto;
      .title {
        line-height: inherit !important;
        margin-top: 0 !important;
      }
      .left,
      .right {
        padding: 56px 20px 80px;
        width: 100%;
        display: block;
        min-height: auto;
        float: none;

        .content {
          float: none;
          width: 100%;
          margin: 0;
        }
      }

      .referral {
        margin-top: 0 !important;
      }
      
      .referral,
      .content-bottom {
        &:after {
          content: '';
          display: table;
          clear: both;
        }
      }
      
      .content-bottom {
        text-align: center;
        .number-box {
          text-align: left;
          &:last-child {
            margin-right: 0 !important;
          }
        }
      }
      .content-bottom-wrapper {
        display: inline-block;
      }

      .left {
        padding-bottom: 50px;
      }
    }
  }
</style>
